;***** LED Fader version 2. LedRec include file
;      Copyright (c) 2003, Mikael Ejberg Pedersen
;      This program is free for personal use.
;
;	Last edited for version 2.01


.equ	LedRecCurrent	=0
.equ	LedRecFinal	=1
.equ	LedRecDuration	=2	; word
.equ	LedRecCounter	=4	; word
.equ	LedRecSlope	=6
.equ	LedRecSize	=7

.dseg
LedRec:		.byte PWMChannels * LedRecSize


.cseg

LedRec_Init:
	ldi	ZL,low(LedRec)
	ldi	ZH,high(LedRec)
	clr	w1
	ldi	w2,PWMChannels*LedRecSize
LRI_ClearLedRecs:
	st	Z+,w1
	dec	w2
	brne	LRI_ClearLedRecs
	ret
	

ExecuteLedRec_W12345Y:			;Z points to LedRec record to execute
	ldd	w1,Z+LedRecCurrent
	ldd	w2,Z+LedRecFinal
	cp	w1,w2			;Final reached already?
	breq	ELR_Exit		; then just exit
	ldd	YL,Z+LedRecCounter
	ldd	YH,Z+LedRecCounter+1
	ldd	w3,Z+LedRecSlope
	mov	w4,w3
	andi	w4,0x7f
	clr	w5
	sub	YL,w4
	sbc	YH,w5
	ldd	w4,Z+LedRecDuration
	ldd	w5,Z+LedRecDuration+1
	tst	w3
	brmi	ELR_NegativeSlope
	ldi	w3,1
	rjmp	ELR_Loop
ELR_NegativeSlope:
	ldi	w3,-1
ELR_Loop:
	tst	YH
	brpl	ELR_Finished
	add	w1,w3
	add	YL,w4
	adc	YH,w5
	rjmp	ELR_Loop
ELR_Finished:
	std	Z+LedRecCounter,YL
	std	Z+LedRecCounter+1,YH
	tst	w3
	brmi	ELR_NegativeSlope2
	cp	w2,w1
	rjmp	ELR_CheckEndStop
ELR_NegativeSlope2:
	cp	w1,w2
ELR_CheckEndStop:
	brpl	ELR_StoreCurrent
	mov	w1,w2
ELR_StoreCurrent:
	std	Z+LedRecCurrent,w1
ELR_Exit:
	ret


UpdateLedRecs_WXYZ:
	ldi	ZL,low(LedRec)
	ldi	ZH,high(LedRec)
	ldi	XL,low(PWMTable)
	ldi	XH,high(PWMTable)
	ldi	w6,PWMChannels
UL_Loop:
	rcall	ExecuteLedRec_W12345Y
	ldd	w1,Z+LedRecCurrent
	st	X+,w1			; Store value in PWMTable
	adiw	ZH:ZL,LedRecSize
	dec	w6
	brne	UL_Loop
	ret


; CalculateLedFadeParams sets up runtime parameters
; for LED fading. Final and duration must be set
; before calling this function.
; Y must point to the relevant LedRec.
CalculateLedFadeParams_W12X:
	ldd	w1,Y+LedRecFinal	; Read final value
	ldd	w2,Y+LedRecCurrent	; Read current value
	sub	w1,w2			; Calculate slope
	brpl	CLFP_PositiveSlope
	neg	w1			; Convert Two's complement to sign-magnitude
	ori	w1,0x80			; MSB used as sign bit
CLFP_PositiveSlope:
	std	Y+LedRecSlope,w1
	ldd	XL,Y+LedRecDuration
	ldd	XH,Y+LedRecDuration+1
	sbiw	XH:XL,1			; Duration-1
	lsr	XH			; (Duration-1)/2
	ror	XL
	std	Y+LedRecCounter,XL
	std	Y+LedRecCounter+1,XH
	ret

